/** @implements {Matcher} */
export class ExactStringMatcher {
  /**
   * @type {string}
   * @readonly
   */
  pattern

  /**
   * @type {boolean}
   * @readonly
   */
  negating

  /**
   * @param {string} pattern
   * @param {boolean} negating
   */
  constructor(pattern, negating) {
    this.pattern = pattern
    this.negating = negating
  }

  /** @type {Matcher[]} */
  children = []

  /**
   * @param {import("../fs/LazyEntry.js").LazyEntry} entry
   * @param {MatchOptions} _options
   * @return {MatchResult}
   */
  match(entry, _options) {
    if (this.pattern === entry.name) {
      return this.children.length === 0 ? 'terminal' : 'partial'
    } else {
      return 'none'
    }
  }
}
